/*list of all possible options in DHMTLX grid
	myGrid.enableSmartRendering(true); -->paging wont' work
	myGrid.enableDragAndDrop(true);
	myGrid.enableRowsHover(true,"hover"); --> must add style .hover
	myGrid.enableKeyboardSupport(false);
	myGrid.enableColumnMove(true);
	myGrid.enableLightMouseNavigation(true);
	myGrid.attachEvent("onKeyPress", onKeyPressed);
	

	mygrid.forceLabelSelection(true); --> only copy the label that is visible, not the value itself
	myGrid.load("components/loadData.cfc?method=loadGridData", "json");
*/

/*optional function
	function onKeyPressed(code,ctrl,shift){ //copy block to clipboard
		if(code==81&&ctrl){
			myGrid.selectAll();	
		}
		if(code==67&&ctrl){
				myGrid.setCSVDelimiter("\t")
				myGrid.copyBlockToClipboard()
		}
		if(code==86&&ctrl){
				myGrid.pasteBlockFromClipboard()
		}
		return true;
	}
	
	<a href="javascript:void(0)" onclick="mygrid.moveRowDown(mygrid.getSelectedId())">Move selected row down</a>
*/

/*
	Notes:
	-) ColTypes ed consists of ed, edtxt (ed will render html tag), edn
*/

var manufacturer;
var manufacturerSelected;
var productType;
var productTypeSelected;
var colorType;
var productnName;
var price;
var launchDate;
var maxVolume;
var notes;
var myGrid;
var dp;

jQuery(document).ready(function() {
	myGrid = new dhtmlXGridObject("myGrid");
	init(myGrid);
	
	//delete selected row
	jQuery("#btnDelete").click(function(){ myGrid.deleteSelectedRows() })
	
	//update column
	jQuery("#col0").change(function(){ updateRow("#manufacturerList", 0) });
	jQuery("#col1").change(function(){
		updateRow("#productTypeList", 1);
		changeColor(); //change the color chosen by radio button
	});
	jQuery("#col2").change(function(){
		var mayChange = checkType(); //check the type of device before changing color
		if ( mayChange === false ){
			alert("The color you choose is incompatible with the device type. Please choose the correct device to change color type.");
			changeColor();
			return;	
		}
		updateRow("input[name:rdoType]:checked",2)
	});
});

function init(myGrid){
	myGrid.setImagePath("css/imgs/");
	
	myGrid.setHeader("Manufacturer, Product Type, Color, Product Name, Price, Launch Date, Product Age, Max Volume, Notes");
	myGrid.attachHeader("#connector_select_filter,#connector_select_filter,#rspan,#connector_text_filter,#connector_text_filter,#connector_text_filter,#connector_text_filter,#connector_text_filter,#connector_text_filter");
	myGrid.setInitWidths("200,200,100,250,200,200,200,200,500");
	
	myGrid.setColTypes("coro,coro,edtxt,edtxt,edn,edtxt,ro,edn,txt");
	myGrid.setColSorting("connector,connector,connector,connector,connector,connector,connector,connector,connector");
	myGrid.setColAlign("left,left,left,left,right,left,right,right,justify");
	
	myGrid.enableMultiselect(true);
	myGrid.enableMultiline(true);
	myGrid.enableBlockSelection(true);
	
	myGrid.setNumberFormat("$ 0,000.00",4);
	myGrid.setNumberFormat("0,000",6);
	
	myGrid.enablePaging(true, 25, 10, "pagingArea", true, "infoArea");
	myGrid.setPagingWTMode(true,true,true,[25,50,100,1000]);
	myGrid.setPagingSkin("toolbar","dhx_skyblue");
	
	myGrid.attachEvent("onRowSelect",doOnRowSelected);
	
	myGrid.init();
	
	myGrid.loadXML("connector/connector.cfm");
	
	dp = new dataProcessor("connector/connector.cfm");
	dp.init(myGrid);					
}

function doOnRowSelected(id){
	var rowId = myGrid.getSelectedId();
	if ( rowId == null ) return;
		
	manufacturer = myGrid.getCombo(0);
	manufacturerSelected = myGrid.cellById(rowId, 0).getValue();
	productType = myGrid.getCombo(1);
	productTypeSelected = myGrid.cellById(rowId, 1).getValue();
	colorType = myGrid.cellById(rowId,2).getValue();
	productName = myGrid.cellById(rowId,3).getValue();
	price = myGrid.cellById(rowId,4).getValue();
	launchDate = myGrid.cellById(rowId,5).getValue();
	maxVolume = myGrid.cellById(rowId,6).getValue();
	notes = myGrid.cellById(rowId,7).getValue();
		
	jQuery("#tblEdit").show();
	fillTableEdit();		
}

function fillTableEdit(){
	var n, optionString;
	//manufacturer field
	var manufacturerKeys = manufacturer.getKeys();
	var manufacturerList = new Array();
	
	n = manufacturerKeys.length
	for (var i=1; i<=n; ++i){
		manufacturerList[i] = manufacturer.get(manufacturerKeys[i-1]);	
	}
	
	n = manufacturerList.length;
	optionString = '<select name="manufacturer" id="manufacturerList">';
	for (var i=1; i<n; ++i){
		var selected = '';
		if ( manufacturerSelected == manufacturerKeys[i-1] ) selected = ' selected="selected"';
		optionString += '<option value="'+ manufacturerKeys[i-1] +'" '+ selected +'>' + manufacturerList[i] + '</option>';	
	}
	optionString += '</select>';
	
	jQuery("#col0").html(optionString);
	//end of manufaturer field
	
	//product type field
	var productTypeKeys = productType.getKeys();
	var productTypeList = new Array();
	
	n = productTypeKeys.length
	for (var i=1; i<=n; ++i){
		productTypeList[i] = productType.get(productTypeKeys[i-1]);	
	}
	
	n = productTypeList.length;
	optionString = '<select name="productType" id="productTypeList">';
	for (var i=1; i<n; ++i){
		var selected = '';
		if ( productTypeSelected == productTypeKeys[i-1] ) selected = ' selected="selected"';
		optionString += '<option value="'+ productTypeKeys[i-1] +'" '+ selected +'>' + productTypeList[i] + '</option>';	
	}
	optionString += '</select>';
	
	jQuery("#col1").html(optionString);
	//end of productTypeField
	
	//isColor field
	var radioString;
	if ( colorType == 0 ){
		var radioString0 = '<label><input type="radio" name="rdoType" value="0" id="rdoMono" checked />Mono</label><br />';
		var radioString1 = '<label><input type="radio" name="rdoType" value="1" id="rdoColor" />Color</label>';
		radioString = radioString0 + radioString1;
	}
	else if ( colorType == 1){
		var radioString0 = '<label><input type="radio" name="rdoType" value="0" id="rdoMono" />Mono</label><br />';
		var radioString1 = '<label><input type="radio" name="rdoType" value="1" id="rdoColor" checked />Color</label>';
		radioString = radioString0 + radioString1;
	}
	jQuery("#col2").html(radioString);
	
	function formData(){
		this.manufacturer = manufacturerList;
		this.productType = productType;
		this.colorType = colorType;
		this.productName = productName;
		this.price = price;
		this.launchDate = launchDate;
		this.maxVolume = maxVolume;
		this.notes = notes;	
	}
	ko.applyBindings(new formData());
}

function updateRow(id, col){ //update selected row
	var rowId = myGrid.getSelectedId();
	var newVal = jQuery(id).val();
		
	myGrid.cellById(rowId, col).setValue(newVal);
	dp.setUpdated(rowId, true);	
}

function changeColor(){
	var rowId = myGrid.getSelectedId();
	var product = jQuery("select#productTypeList option:selected").text();
	var rdoGroup = jQuery("input:radio[name=rdoType]");
	if ( product.indexOf("Mono") >= 0 ){ //change radio button value to mono
		rdoGroup.filter("[value=0]").attr('checked', true);
	}
	else if ( product.indexOf("Color") >= 0 ){ //change radio button value to color
		rdoGroup.filter("[value=1]").attr('checked', true);
	}
	updateRow("input[name:rdoType]:checked",2)
}

function checkType(){ //check the type of the device before changing the device color
	var product = jQuery("select#productTypeList option:selected").text();
	var color = jQuery("input:radio[name=rdoType]:checked").val();
	
	if ( product.indexOf("Mono") >= 0 ) return color == 0;
	else if ( product.indexOf("Color") >= 0 ) return color == 1;
}